#!/bin/sh
#
# Rubi's Ultimate Backup Implementation
#
# Version 3.0, (C) 2.2004 by Beat Rubischon <rubischon@phys.ethz.ch>
#		   3.1999 by Beat Rubischon <beat@rubis.ch>
#                  8.1999 by Beat Rubischon <beat.rubischon@trivadis.com>
#                  2.2000 by Beat Rubischon <beat@rubis.ch>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# $Id: functions.sh,v 1.9 2004/07/07 08:57:19 beat Exp $
#
# Subroutines for rubi

# -----------------
# do the dirty work
# -----------------
doit () {

#
# upgrade client
    if [ "$SRCHOST" != "localhost" ]; then
	(cd /; tar cf - \
	  .$PREFIX/COPYING \
	  .$PREFIX/VERSION \
	  .$PREFIX/lib/[a-z]* ) \
	  | $SSH $SRCHOST "cd /; tar xfp -"
    fi

#
# do backup
    mkdir -p $DSTDIR
    cd $DSTDIR
    $PREFIX/lib/backup.pl "$PREFIX" "$SSH" "$MKFIFO" "$CPIO" "$RSYNC" \
      "$SRCCPIO" "$SRCRSYNC" "$SRCHOST" "$SRCPART" "$BASEDST" \
      "$DSTDIR" "$OLDDST" 2>&1
    if [ $? -eq 0 ]; then
	echo $DSTDIR > $BASEDST/lastdst

#
# expunge
        if [ "$KEEPS" = "" ]; then
	    $FIND $BASEDST -maxdepth 1 -ctime +$KEEPD -type d \
	      | (while read dir; do
	        echo -n "deleting $dir..."
	        rm -Rf $dir
	        rm -f $dir.log
	        echo "done."
	        done)
        else
	    $FIND $BASEDST -maxdepth 1 -ctime +$KEEPD -type d \
	      | egrep -v "$KEEPS" \
	      | (while read dir; do
	        echo -n "deleting $dir..."
	        rm -Rf $dir
	        rm -f $dir.log
	        echo "done."
	        done)

        fi
        echo
	echo "* * * Backup successfull * * *"
	echo
#
# failed
    else
	rmdir $DSTDIR 2>/dev/null
	echo
	echo "* * * Backup failed * * *"
	echo
    fi
}
